glibmm 2.56.0

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gio::TcpConnection Class Reference
Portable Network I/O Functionality

A TCP SocketConnection. More...

`#include <giomm/tcpconnection.h>`

Inheritance diagram for Gio::TcpConnection:
[legend]

## Public Member Functions
| TcpConnection (TcpConnection&& src) noexcept
TcpConnection& | operator= (TcpConnection&& src) noexcept
| ~TcpConnection () noexcept override
GTcpConnection* | gobj ()
| Provides access to the underlying C GObject. More...
const GTcpConnection* | gobj () const
| Provides access to the underlying C GObject. More...
GTcpConnection* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | set_graceful_disconnect (bool graceful_disconnect)
| This enables graceful disconnects on close. More...
bool | get_graceful_disconnect () const
| Checks if graceful disconnects are used. More...
Glib::PropertyProxy< bool > | property_graceful_disconnect ()
| Whether or not close does a graceful disconnect. More...
Glib::PropertyProxy_ReadOnly< bool > | property_graceful_disconnect () const
| Whether or not close does a graceful disconnect. More...
Public Member Functions inherited from Gio::SocketConnection
| SocketConnection (SocketConnection&& src) noexcept
SocketConnection& | operator= (SocketConnection&& src) noexcept
| ~SocketConnection () noexcept override
GSocketConnection* | gobj ()
| Provides access to the underlying C GObject. More...
const GSocketConnection* | gobj () const
| Provides access to the underlying C GObject. More...
GSocketConnection* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | connect (const Glib::RefPtr< SocketAddress >& address, const Glib::RefPtr< Cancellable >& cancellable)
| Connect connection to the specified remote address. More...
bool | connect (const Glib::RefPtr< SocketAddress >& address)
| A connect() convenience overload. More...
void | connect_async (const Glib::RefPtr< SocketAddress >& address, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable)
| Asynchronously connect this connection to the specified remote address. More...
void | connect_async (const Glib::RefPtr< SocketAddress >& address, const SlotAsyncReady& slot)
| A non-cancellable version of connect_async(). More...
bool | connect_finish (const Glib::RefPtr< AsyncResult >& result)
| Gets the result of a g_socket_connection_connect_async() call. More...
bool | is_connected () const
| Checks if connection is connected. More...
Glib::RefPtr< Socket > | get_socket ()
| Gets the underlying Socket object of the connection. More...
Glib::RefPtr< const Socket > | get_socket () const
| Gets the underlying Socket object of the connection. More...
Glib::RefPtr< SocketAddress > | get_local_address ()
| Try to get the local address of a socket connection. More...
Glib::RefPtr< const SocketAddress > | get_local_address () const
| Try to get the local address of a socket connection. More...
Glib::RefPtr< SocketAddress > | get_remote_address ()
| Try to get the remote address of a socket connection. More...
Glib::RefPtr< const SocketAddress > | get_remote_address () const
| Try to get the remote address of a socket connection. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Socket > > | property_socket () const
| The underlying GSocket. More...
Public Member Functions inherited from Gio::IOStream
| IOStream (IOStream&& src) noexcept
IOStream& | operator= (IOStream&& src) noexcept
| ~IOStream () noexcept override
GIOStream* | gobj ()
| Provides access to the underlying C GObject. More...
const GIOStream* | gobj () const
| Provides access to the underlying C GObject. More...
GIOStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | splice_async (const Glib::RefPtr< IOStream >& stream2, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, IOStreamSpliceFlags flags=Gio::IO_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| Asyncronously splice the output stream to the input stream of stream2, and splice the output stream of stream2 to the input stream of this stream. More...
void | splice_async (const Glib::RefPtr< IOStream >& stream2, const SlotAsyncReady& slot, IOStreamSpliceFlags flags=Gio::IO_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| A non-cancellable version of splice_async(). More...
Glib::RefPtr< InputStream > | get_input_stream ()
| Gets the input stream for this object. More...
Glib::RefPtr< OutputStream > | get_output_stream ()
| Gets the output stream for this object. More...
bool | close (const Glib::RefPtr< Cancellable >& cancellable)
| Closes the stream, releasing resources related to it. More...
bool | close ()
| A close() convenience overload. More...
void | close_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
void | close_async (const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
bool | close_finish (const Glib::RefPtr< AsyncResult >& result)
| Closes a stream. More...
bool | is_closed () const
| Checks if a stream is closed. More...
bool | has_pending () const
| Checks if a stream has pending actions. More...
bool | set_pending ()
| Sets stream to have actions pending. More...
void | clear_pending ()
| Clears the pending flag on stream. More...
Public Member Functions inherited from Glib::Object
| Object (const Object&)=delete
Object& | operator= (const Object&)=delete
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gio::SocketConnection
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< SocketConnection > | create (const Glib::RefPtr< Socket >& socket)
| Creates a SocketConnection subclass of the right type for socket. More...
Static Public Member Functions inherited from Gio::IOStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static bool | splice_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an asynchronous io stream splice operation. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::TcpConnection > | wrap (GTcpConnection* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::SocketConnection
Glib::RefPtr< Gio::SocketConnection > | wrap (GSocketConnection* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::IOStream
Glib::RefPtr< Gio::IOStream > | wrap (GIOStream* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)

## Detailed Description

A TCP SocketConnection.

This is the subclass of SocketConnection that is created for TCP/IP sockets.

Since glibmm 2.24:

## Constructor & Destructor Documentation

## ◆ TcpConnection()

Gio::TcpConnection::TcpConnection | ( | TcpConnection&& | src | ) |
| noexcept

## ◆ ~TcpConnection()

Gio::TcpConnection::~TcpConnection | ( |  | ) |
| override noexcept

## Member Function Documentation

## ◆ get_graceful_disconnect()

bool Gio::TcpConnection::get_graceful_disconnect | ( |  | ) | const

Checks if graceful disconnects are used.

See g_tcp_connection_set_graceful_disconnect().

Since glibmm 2.22:

Returns
  `true` if graceful disconnect is used on close, `false` otherwise.

## ◆ get_type()

static GType Gio::TcpConnection::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GTcpConnection* Gio::TcpConnection::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GTcpConnection* Gio::TcpConnection::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GTcpConnection* Gio::TcpConnection::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

TcpConnection& Gio::TcpConnection::operator= | ( | TcpConnection&& | src | ) |
| noexcept

## ◆ property_graceful_disconnect() [1/2]

Glib::PropertyProxy< bool > Gio::TcpConnection::property_graceful_disconnect | ( |  | ) |

Whether or not close does a graceful disconnect.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_graceful_disconnect() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gio::TcpConnection::property_graceful_disconnect | ( |  | ) | const

Whether or not close does a graceful disconnect.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_graceful_disconnect()

void Gio::TcpConnection::set_graceful_disconnect | ( | bool | graceful_disconnect | ) |

This enables graceful disconnects on close.

A graceful disconnect means that we signal the receiving end that the connection is terminated and wait for it to close the connection before closing the connection.

A graceful disconnect means that we can be sure that we successfully sent all the outstanding data to the other end, or get an error reported. However, it also means we have to wait for all the data to reach the other side and for it to acknowledge this by closing the socket, which may take a while. For this reason it is disabled by default.

Since glibmm 2.22:

Parameters

  graceful_disconnect | Whether to do graceful disconnects or not.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::TcpConnection > wrap | ( | GTcpConnection * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.